function tg(id,numRows) {
  // Toggle a row's visibility
  // id: The Id number of the root row. Its children will be toggled.
  // numRows: The total number of child rows for this root.
  var rootRowNum = Number(id.substring(2)); // format: "r_6" etc.
  var rootElement = document.getElementById(id);
  var rootDepth = rootElement.getAttribute("depth");
  var action = "";
  var text = document.getElementById(id + "-tg").firstChild;
  if (text.nodeValue == "[+]") {
    action = "reveal";
    text.nodeValue = "[-]";
  } else {
    action = "hide";
    text.nodeValue = "[+]";
  }
//alert("id=" + id + " numRows=" + numRows + " rootDepth="  + rootDepth + " action="  + action);
  for (var i=1; i <= numRows; i++) {
    var thisRowNum = rootRowNum + i;
    var childId = "r_" + thisRowNum;
    var childElement = document.getElementById(childId);
    var childDepth = childElement.getAttribute("depth");
    var childNumChildren = childElement.getAttribute("num-children");
    if (action == "hide") {
      var toggle = document.getElementById(childId + "-tg")
      if (toggle != null) {
        toggle.firstChild.nodeValue = "[+]";
      }
      childElement.style.display = "none";
    }
    else { // action == "reveal"
      if ((childDepth - rootDepth) == 1) {
        childElement.style.display = "";
      }
      else {
        // skip its children, as they are already hidden
        i += childNumChildren;
      }
    }
  }
}

function showAll(numRows) {
  for (var i=2; i <= Number(numRows)+1; i++) {
    var rowNum = "r_" + i;
    var row = document.getElementById(rowNum);
    if ( row.style.display == "none" ) {
      row.style.display = "";
    }
    var toggle = document.getElementById(rowNum + "-tg");
    if (toggle != null) {
      if (toggle.firstChild.nodeValue == "[+]") {
        toggle.firstChild.nodeValue = "[-]";
      }
    }
  }
}

function hideAll(numRows) {
  for (var i=2; i <= Number(numRows)+1; i++) {
    var rowNum = "r_" + i;
    var row = document.getElementById(rowNum);
    var depth = row.getAttribute("depth");
    if ( depth > 1 ) {
        row.style.display = "none";
    }
    var toggle = document.getElementById(rowNum + "-tg");
    if (toggle != null) {
      toggle.firstChild.nodeValue = "[+]";
    }
  }
}
